*
* read.s
*
* v0.2 26/10/01
*
* user command for reading data from the socket
*
* first fetch data.
* look whether some acceptable data is available. If so, pushes it
* else, if non block, timeout
*       else tick & timeout if needed
*

ASSEMBLE
	CON(1)		8
RPL
xNAME READ
::
  CK1&Dispatch
    #1F	::
      Rclpar
CODE
	GOSUBL	=checksocketnumber
	GOSUBL	=ckpppisconn
	GOSUBL	=ztick

:readloop
	GOSUBL	=rechdlc		fetch data !

	A=R4.F	A
	LC(5)	socketrcvd
	C=C+A	A
	D0=C	A

	C=DAT0	A
	?C#0	A			are there data ?
	GOYES	+
	GOTO	readloopend

+
* some data are in socket buffer
	R0=C.F	A			size (nibbles)
	R1=C.F	A			size to drop in buffer

	D0+	(socketpointer)-(socketrcvd)
	C=DAT0	A
	D=C	A

	LC(5)	offsetbufsock
	C=C+A	A
	C=C+D	A
	D0=C	A

	?ST=1	_b_st_Readln
	GOYES	+
	GOTO	readblock

+
* Readln : look for CR+LF of LF alone
	D1=C	A			for parsing
	C=R0.F	A
	D=C	A			D counts nibbles left

	LC(2)	_CR
	B=C	B
	LC(2)	_LF

:loopreadln
	A=DAT1	B
	?A=B	B			CR, let's remove eventual LF
	GOYES	readCRLF
	?A=C	B			LF, ok
	GOYES	readlnok

	D1+	2
	D-CON	A,2			one byte less
	GONC	loopreadln

	GOTO	readloopend		couldn't find CRLF or LF, sig !

:readCRLF
	D1+	2
	A=DAT1	B
	?A#C	B			no LF after CR ?! ok
	GOYES	readlnok

	D-CON	A,2			eat CR
	GONC	+
	GOTO	readloopend
+
	C=R0.F	A
	C-CON	A,2			do not push CR
	R0=C.F	A

:readlnok
	C=R0.F	A			what we will push
	C-D	A
	R0=C.F	A

	C=R1.F	A			what we drop in buffer
	C-D	A			what we scanned (but LF)
	C+CON	A,2			drop LF
	R1=C.F	A

:readblock
	D0-	5			-> header + size
	C=R0.F	A
	C=C+CON	A,5			plus the size's size
	DAT0=C	A

	D0-	5
	LC(5)	=DOCSTR
	DAT0=C	A
	AD0EX

	PUSH

	A=R4.F	A
	LC(5)	socketrcvd
	A+C	A
	D0=A	A

	C=DAT0	A
	A=R1.F	A
	C-A	A			remove what we drop
	DAT0=C	A

	D0+	(socketpointer)-(socketrcvd)

	C=DAT0	A
	C+A	A			new pointer
	DAT0=C	A

	D0-	(socketpointer)-(socketconnection)

	C=DAT0	P
	?C=0	P
	GOYES	+			udp, no window

* tcp -> reopens the window ?
	D0+	(tcpconnected)-(socketconnection)
	C=DAT0	P
	?C=0	P			he isn't connected any more,
	GOYES	+			we shan't reopen the window !

	GOSUBL	=tcpopenwindow
+
	GOTOL	=exit


:readloopend
	A=R4.F	A
	LC(5)	socketconnection
	C=C+A	A
	D0=C	A

	C=DAT0	P
	?CBIT=0	0			udp or raw ?
	GOYES	+

* TCP and no data available, check connection
	D0+	(tcpconnected)-(socketconnection)
	C=DAT0	P
	?C#0	P			still connected ?
	GOYES	+

	LC(5)	XErr_Disconn
	GOTOL	=erreur

+
	?ST=1	_b_st_NBlock		if non block, go directly to timeout
	GOYES	readtimeout

	GOSUBL	=tick			timer & test
	GONC	+
	GOTO	readtimeout
+
	GOTO	readloop

:readtimeout
	LA(5)	=NULL$
	PUSH
	GOTOL	=exit

ENDCODE
    ;
;

