*
* write.s
*
* v0.2 01/01/02
*
* user command for writing data on the socket
*

ASSEMBLE
	CON(1)		8
RPL
xNAME WRITE
::
  CK2&Dispatch
    #31F ::
      Rclpar
CODE
	GOSUBL	=checksocketnumber
	GOSUBL	=ckpppisconn

	A=DAT1	A
	D0=A	A
	D0+	5			size in nibbles
	C=DAT0	A
	C=C-CON	A,5			substract size's size
	R0=C.F	A
	D0+	5			data
* XXX don't touch D0 !

* check early whether it is a tcp socket
	A=R4.F	A
	LC(5)	sockettype
	C+A	A
	D1=C

	A=DAT1	P
	B=A	P
	LC(1)	SOCK_STREAM
	?C=A	P
	GOYES	writetcp

* not tcp : we can't split
	D1-	(sockettype)-(mtu)
	A=DAT1	A			mtu in bytes

* let's see what we will add to that string

	LC(1)	SOCK_RAW
	?B=C	P			B still holds socket type
	GOYES	+

	C=0	A
	LC(2)	8+20
	A=A-C	A			udp+ip header size
+
	A+A	A			mtu in nibbles
	C=R0.F	A			size to send

	?C<=A	A			holds in mtu ?
	GOYES	+

	LC(5)	XErr_MTU
	GOTOL	=erreur

+
	GOSUB	=sendsock

	GOLONG	=drop

:notconn
	LC(5)	XErr_AlDisconn
	GOLONG	=erreur

:writetcp


* check that we are still connected
	A=R4.F	A
	LC(5)	socketconnected
	A+C	A
	D1=A

	C=DAT1	P
	?C=0	P
	GOYES	notconn

* records size, address, etc...
	D1+	(sockettosend)-(socketconnected)

	C=R0.F	A
	CSRB.F	A			in bytes
	DAT1=C	A
	D1+	(socket@tosend)-(sockettosend)
	CD0EX	A
	DAT1=C	A
	D1+	(socketsent)-(socket@tosend)
	C=0	A
	DAT1=C	A

* sets the window at the beginning
	D1+	(tcpseq)-(socketsent)
	C=DAT1	8
	D1-	(tcpseq)-(tcpoldseq)
	DAT1=C	8			fully acked last time

* I must use it one day !!! But still annoying because incremented in
* ppp/send.a
*	D1-	(tcpoldseq)-(cptimeout)
*	LC(1)	_num_retries
*	DAT1=C	P

	GOSUBL	=ztick

:loopwritetcp
*	A=R4.F	A
*	LC(5)	cptimeout
*	C+A	A
*	D1=C
*
*	C=DAT1	P
*	?C#0	P
*	GOYES	+
*	GOTO	writetimeout
*
*+
	A=R4.F	A
	D1=A
	D1+	mtu
	A=DAT1	A
	C=0	A
	LC(2)	20+20			for ip + tcp header
	A-C	A

	B=A	A			what we can send

	A=R4.F	A
	LC(5)	tcpwindow
	C+A	A
	D1=C
	A=DAT1	A			his window

	D1-	(tcpwindow)-(socketsent)
	C=DAT1	A
	A=A-C	A			win=hiswin-sent

	?A>=B	A
	GOYES	+

	B=A	A			it's the window which restricts data
+
	D1-	(socketsent)-(sockettosend)
	A=DAT1	A

	C=A-C	A			tosend - sent = what we need to send
	?C<=B	A			does it fit in the restriction ?
	GOYES	+
	C=B	A
+
* C contains what we will send

	?C=0	A
	GOYES	socketcantwrite

	C+C	A
	R0=C.F	A			size in nibbles in R0[A]
	CSRB.F	A

	D1+	(socketsent)-(sockettosend)
	A=DAT1	A			sent
	B=0	W					(for later use)
	B=A	A			is saved
	A=A+C	A			and
	DAT1=A	A			increased

	D1-	(socketsent)-(socket@tosend)
	C=DAT1	A

	C=C+B	A
	C=C+B	A			(! nibbles)
	D0=C

	D1+	(tcpoldseq)-(socket@tosend)
	C=DAT1	8

	P=	7
	C=C+B	WP			B=0	W used here
	P=	0

	D1+	(tcpseq)-(tcpoldseq)	seq number of these data
	DAT1=C	8

	GOSUB	=sendsock		send it !

:socketcantwrite
	A=R4.F	A
	LC(5)	(sockettosend)
	C+A	A
	D0=C

	C=DAT0	A
	?C#0	A
	GOYES	+

	D0+	(tcpoldseq)-(sockettosend)
	C=DAT0	8
	D0+	(tcpseq)-(tcpoldseq)
	DAT0=C	8
	GOLONG	=drop			finished !!!!

+
	GOSUBL	=rechdlc

	A=R4.F	A
	LC(5)	(tcpoldseq)
	C+A	A
	D0=C

	C=DAT0	8

	D0+	(tcpacked)-(tcpoldseq)
	A=C	W
	A=DAT0	8

	?C#A	W
	GOYES	writeshiftwin

* stalled
	GOSUBL	=tick
	GONC	+
* we waited for long ! Let's try to resend it
	GOSUBL	=ztick
	A=R4.F	A
	LC(5)	(socketsent)
	C+A	A
	D0=C

	C=0	A
	DAT0=C	A			simply believe we didn't send anything !

+
	GOTO	loopwritetcp

:writeshiftwin
* data was acked, so shift the window !
	P=	7
	C=A-C	WP			new - old = window shift
	P=	0

* shift seq
	D0-	(tcpacked)-(tcpoldseq)
	DAT0=A	8			new fully acked

* shift sent
	D0-	(tcpoldseq)-(socketsent)
	A=DAT0	A
	A=A-C	A			part of sent data was acked
	DAT0=A	A

* shift @tosend
	D0-	(socketsent)-(socket@tosend)
	A=DAT0	A
	A=A+C	A
	A=A+C	A			! nibbles
	DAT0=A	A

* shift tosend
	D0-	(socket@tosend)-(sockettosend)
	A=DAT0	A
	A=A-C	A	
	DAT0=A	A

	GOTO	loopwritetcp
	

:writetimeout
	LC(5)	XErr_Time
	GOTOL	=erreur

ENDCODE
    ;
;
